#include "config.h"
#include "cpm_collectives.h"
#include "cpm_functional.hpp"
#include "MPIBlib/collectives/br_tree_algorithms.hpp"
#include "models/cpm_brsg_tree_builders.hpp"
#include "models/cpm_utils.h"

using namespace CPM::BRSG;

extern "C" int CPM_Bcast_dfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
		void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
{
	return MPIB_Bcast_tree_algorithm(DFS_binomial_builder(predictor, next_node, BR), R2L,
		buffer, count, datatype, root, comm);
}

extern "C" int CPM_Reduce_dfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
		void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
		MPI_Op op, int root, MPI_Comm comm)
{
	return MPIB_Reduce_tree_algorithm(DFS_binomial_builder(predictor, next_node, BR), L2R,
		sendbuf, recvbuf, count, datatype,
		op, root, comm);
}

extern "C" int CPM_Bcast_ucs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
		void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
{
	return MPIB_Bcast_tree_algorithm(UCS_binomial_builder(predictor, next_node, BR), L2R,
		buffer, count, datatype, root, comm);
}

extern "C" int CPM_Reduce_ucs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
		void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
		MPI_Op op, int root, MPI_Comm comm)
{
	return MPIB_Reduce_tree_algorithm(UCS_binomial_builder(predictor, next_node, BR), R2L,
		sendbuf, recvbuf, count, datatype,
		op, root, comm);
}

extern "C" int CPM_Bcast_bfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
		void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
{
	return MPIB_Bcast_tree_algorithm(BFS_binomial_builder(predictor, next_node, BR), L2R,
		buffer, count, datatype, root, comm);
}

extern "C" int CPM_Reduce_bfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
		void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
		MPI_Op op, int root, MPI_Comm comm)
{
	return MPIB_Reduce_tree_algorithm(BFS_binomial_builder(predictor, next_node, BR), R2L,
		sendbuf, recvbuf, count, datatype,
		op, root, comm);
}
