#ifndef CPM_FUNCTIONAL_HPP_
#define CPM_FUNCTIONAL_HPP_

#include <functional>
#include <utility>

namespace CPM {
using namespace std;

/*! Auxiliary function object that compares the second field of a pair. */
struct second_less: public binary_function<pair<int, double>, pair<int, double>, bool> {
	bool operator()(const pair<int, double>& x, const pair<int, double>& y) const {
		return x.second < y.second;
	}
};

/*! Auxiliary function object that compares the second field of a pair. */
struct second_greater: public binary_function<pair<int, double>, pair<int, double>, bool> {
	bool operator()(const pair<int, double>& x, const pair<int, double>& y) const {
		return x.second > y.second;
	}
};
}

#endif /* CPM_FUNCTIONAL_HPP_ */
