#include "config.h"
#include "cpm_collectives.h"
#include "cpm_functional.hpp"
#include "MPIBlib/collectives/sg_tree_algorithms.hpp"
#include "models/cpm_brsg_tree_builders.hpp"
#include "models/cpm_utils.h"

using namespace CPM::BRSG;

extern "C" int CPM_Scatter_dfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
	void* sendbuf, int sendcount, MPI_Datatype sendtype,
	void* recvbuf, int recvcount, MPI_Datatype recvtype,
	int root, MPI_Comm comm)
{
	return MPIB_Scatter_tree_algorithm(DFS_binomial_builder(predictor, next_node, SG), R2L,
			sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
}

extern "C" int CPM_Gather_dfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
	void* sendbuf, int sendcount, MPI_Datatype sendtype,
	void* recvbuf, int recvcount, MPI_Datatype recvtype,
	int root, MPI_Comm comm)
{
	return MPIB_Gather_tree_algorithm(DFS_binomial_builder(predictor, next_node, SG), L2R,
			sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
}

extern "C" int CPM_Scatter_ucs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
	void* sendbuf, int sendcount, MPI_Datatype sendtype,
	void* recvbuf, int recvcount, MPI_Datatype recvtype,
	int root, MPI_Comm comm)
{
	return MPIB_Scatter_tree_algorithm(UCS_binomial_builder(predictor, next_node, SG), L2R,
			sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
}

extern "C" int CPM_Gather_ucs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
	void* sendbuf, int sendcount, MPI_Datatype sendtype,
	void* recvbuf, int recvcount, MPI_Datatype recvtype,
	int root, MPI_Comm comm)
{
	return MPIB_Gather_tree_algorithm(UCS_binomial_builder(predictor, next_node, SG), R2L,
			sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
}

extern "C" int CPM_Scatter_bfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
	void* sendbuf, int sendcount, MPI_Datatype sendtype, 
	void* recvbuf, int recvcount, MPI_Datatype recvtype, 
	int root, MPI_Comm comm)
{
	return MPIB_Scatter_tree_algorithm(BFS_binomial_builder(predictor, next_node, SG), L2R,
			sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
}

extern "C" int CPM_Gather_bfs_binomial(CPM_predictor* predictor, CPM_next_node_strategy next_node,
	void* sendbuf, int sendcount, MPI_Datatype sendtype, 
	void* recvbuf, int recvcount, MPI_Datatype recvtype, 
	int root, MPI_Comm comm)
{
	return MPIB_Gather_tree_algorithm(BFS_binomial_builder(predictor, next_node, SG), R2L,
			sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, comm);
}
