/*!
 * \file
 * For internal use
 */
#ifndef CPM_H_
#define CPM_H_

/*!
 * \page cpm Communication performance models
 * \section library Library
 * A static library \c libcpm.a implements heterogeneous communication performance models
 * and consists of the following modules:
 * - \ref measurement
 * - \ref models
 * - \ref prediction
 * 
 * \dotfile models/modules.dot
 * 
 * \section tools Tools
 * - \subpage model
 * - \subpage prediction
 * - \subpage generate_hierarchy_input_file
 * - \subpage hierarchical_model
 *
 * \section tests Tests
 * - \subpage ranks2hosts
 */

#include "MPIBlib/benchmarks/mpib.h"
#include "cpm_models.h"
#include "cpm_predict_collectives.h"
#include "cpm_output.h"
#include "cpm_utils.h"

#endif /*CPM_H_*/
