#include "cpm_models.h"

double CPM_predict_flat_sgv_parallel(CPM_predictor* predictor, int size, int root, int* size_bytes) {
	double result = 0.;
	int i;
	//return maximum (not sum) of all the P2P transfer times
	for (i = 0; i < size; i++) {
		if (i != root) {
			if (result < predictor->predict_p2p(predictor, root, i, size_bytes[i])) 
				result = predictor->predict_p2p(predictor, root, i, size_bytes[i]);
		}
	}
	return result;
}

double CPM_predict_flat_sg_parallel(CPM_predictor* predictor, int size, int root, int size_bytes) {
	double result = 0.;
	int i;
	//return maximum (not sum) of all the P2P transfer times
	for (i = 0; i < size; i++) {
		if (i != root) {
			if (result < predictor->predict_p2p(predictor, root, i, size_bytes)) 
				result = predictor->predict_p2p(predictor, root, i, size_bytes);
		}
	}
	return result;
}

double CPM_predict_flat_sgv_serial(CPM_predictor* predictor, int size, int root, int* size_bytes) {
	double result = 0.;
	int i;
	//return sum (not maximum) of all the P2P transfer times
	for (i = 0; i < size; i++)
		if (i != root)
			result += predictor->predict_p2p(predictor, root, i, size_bytes[i]);
	return result;
}

double CPM_predict_flat_sg_serial(CPM_predictor* predictor, int size, int root, int size_bytes) {
	double result = 0.;
	int i;
	//return sum (not maximum) of all the P2P transfer times
	for (i = 0; i < size; i++)
		if (i != root)
			result += predictor->predict_p2p(predictor, root, i, size_bytes);
	return result;
}
