#include "cpm_utils.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

CPM_model  getModel(CPM_coll_ops operation) {
	CPM_model model = NULL_MODEL;
	const char* name = CPM_coll_op_names[operation];
	//This special case does not deliver a model in the name
	if (0 == strncmp(name, "P2P", 3))
		return model;
	if (0 == strncmp(name, "HOCKNEY", 6)) 
		model = HOCKNEY;
	if (0 == strncmp(name, "PLOGP", 5))
			model = PLOGP;
	if (0 == strncmp(name, "LOGGP", 5))
			model = LOGGP;
#ifdef HAVE_LIBR
	if (0 == strncmp(name, "LMO", 3))
		model = LMO;
#endif
	if (0 == strncmp(name, "LININTERP", 9))
		model = LININTERP;
	if (0 == strncmp(name, "MPIB", 4))
		model = MPIB_;
	if (model != NULL_MODEL)
		return model;
	else {
		fprintf(stderr, "getModel could not find the model\n");
		exit(-1);
	}
}

CPM_coll_ops findOperation(const char* operation) {
	int i;	
	CPM_coll_ops result = -1;
	for (i = 0 ; i <  NUMBER_OF_OPS; i++) {
		if (0 == strcmp(CPM_coll_op_names[i], operation)) {
			result = i ;
			break;
		}
	}
	return result;
}
