#ifndef CPM_UTILS_H_
#define CPM_UTILS_H_

#include "collectives/cpm_coll_ops_list.h"

#ifdef __cplusplus
extern "C" {
#endif

/*! Strategy defining the selection of a processor for the next node in the communication tree */
typedef enum {MIN, MAX} CPM_next_node_strategy;

/*! Types of models */
typedef enum {NULL_MODEL, MPIB_, LMO, HOCKNEY, LININTERP, PLOGP, LOGGP} CPM_model;

/*! Returns the type of model used in the implementation of collective communication operation */
CPM_model getModel(CPM_coll_ops operation);

/*! Converts the name of the implementation of collective communication operation to the corresponding enum item */
CPM_coll_ops findOperation(const char* operation); 

#ifdef __cplusplus
}
#endif

#endif //CPM_UTILS_H_
