/*!
 * \page ranks2hosts Generator of rank-to-host mapping

 * This program is useful in combination with \ref generate_hierarchy_input_file
 * for debugging and visualization of the actual ranks running on different hosts.
 * It produces a list in Graphviz DOT format.
 *
 * \b Example:
 * \code
 * mpirun -n <np> ranks2hosts > ranks2hosts.out
 * \endcode
 *
 */
#include <mpi.h>
#include <stdio.h>

int main(int argc, char** argv) {
	MPI_Init(&argc, &argv);
	int rank;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	char name[MPI_MAX_PROCESSOR_NAME];
	int len;
	MPI_Get_processor_name(name, &len);
	printf(" %d [label=\"%s\"];\n", rank, name);
	MPI_Finalize();
	return 0;
}
